import { ApolloServer } from 'apollo-server-express';
export declare const typeDefsString = "\n  type Query {\n    authorization: Authorization\n  }\n  type Authorization {\n    try(input: AuthorizationTryInput): AuthorizationTryOutput\n    set(input: AuthorizationSetInput): AuthorizationSetOutput\n    get(input: AuthorizationGetInput): AuthorizationGetOutput\n  }\n  input AuthorizationTryInput {\n    linkId: Int\n  }\n  type AuthorizationTryOutput {\n    id: String\n    error: String\n  }\n  input AuthorizationSetInput {\n    id: String!\n    linkId: Int\n    error: String\n  }\n  type AuthorizationSetOutput {\n    error: String\n  }\n  input AuthorizationGetInput {\n    id: String!\n  }\n  type AuthorizationGetOutput {\n    jwt: JWT\n    error: String\n  }\n  type JWT {\n    token: String\n    linkId: Int\n  }\n";
export declare const typeDefs: import("graphql").DocumentNode;
declare const generateApolloServer: (httpServer: any) => ApolloServer<{
    req: any;
}>;
export default generateApolloServer;
