import { ApolloServer } from 'apollo-server-express';
export declare const typeDefsString = "\n  type Query {\n    packager_install(input: PackagerInstallInput): PackagerInstallOutput\n    packager_publish(input: PackagerPublishInput): PackagerPublishOutput\n  }\n  input PackagerInstallInput {\n    address: String\n  }\n  type PackagerInstallOutput {\n    ids: [Int]\n    errors: [String]\n    packageId: Int\n  }\n  input PackagerPublishInput {\n    id: Int\n    address: String\n  }\n  type PackagerPublishOutput {\n    errors: [String]\n    address: String\n  }\n";
export declare const typeDefs: import("graphql").DocumentNode;
export declare const packagerInstallCore: (errors: any[], address: string) => Promise<{
    errors: any[];
    ids?: undefined;
    packageId?: undefined;
} | {
    ids: number[];
    errors: any[];
    packageId: number;
}>;
export declare const packagerPublishCore: (errors: any[], address: string, id: number) => Promise<{
    errors: any[];
    address?: undefined;
} | {
    errors: any[];
    address: string;
}>;
declare const generateApolloServer: (httpServer: any) => ApolloServer<{
    req: any;
}>;
export default generateApolloServer;
